<!DOCTYPE html>
<html>
<head>
    <title>Visual Ranking: Oceanman Switzerland 2018</title>
    <link rel="icon" href="/icon.png" sizes="32x32">
    <meta charset="utf-8">
    <meta property="og:url" content="https://oceanman-switzerland-2018.muehlemann.com/"/>
    <meta property="og:type" content="article"/>
    <meta property="og:title" content="Visual Ranking: Oceanman Switzerland 2018"/>
    <meta property="og:author" content="Silvan Mühlemann"/>
    <meta property="og:description"
          content="This scatter chart show all participants of the Oceanman Switzerland 2018"/>
    <meta property="og:image" content="https://oceanman2018.muehlemann.com/og-image.png"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script async src="https://www.googletagmanager.com/gtag/js?id=UA-10357230-1"></script>
    <script>
        window.dataLayer = window.dataLayer || [];

        function gtag() {
            dataLayer.push(arguments);
        }

        gtag('js', new Date());

        gtag('config', 'UA-10357230-1');
    </script>


    <link href='https://fonts.googleapis.com/css?family=Poppins' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css">
    <script src="//code.jquery.com/jquery-2.1.1.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.0/clipboard.min.js"></script>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.1.0/css/all.css" integrity="sha384-lKuwvrZot6UHsBSfcMvOkWwlCMgc0TaWr+30HWe3a4ltaBwTZhyTEggF5tJv8tbt" crossorigin="anonymous">
    <link rel="stylesheet" href="node_modules/primer-tooltips/build/build.css">
    <script src="node_modules/primer-tooltips/build/index.js"></script>
    <style>

        body {
            background-color: black;
            color: white;
            margin: 30px;
            font-family: 'Poppins', sans-serif;

        }

        @media (min-width: 768px) {
            .fix-margins {
                padding-left: 16px;
            }
        }

        @media (max-width: 768px) {
            body {
                margin: 0
            }

            p.input-lg, label.input-lg {
                padding-left: 0;
                padding-right: 30px;
            }

            div.margins {
                margin-left: 16px
            }

            h1 {
                margin-left: 16px;
            }
        }

        .chart {
            margin: auto;
        }

        .chart circle {
            fill: #91c7ff;
            opacity: 0.5;
        }

        .chart circle.me {
            fill: red;
            opacity: 1
        }

        .chart circle.women {
            fill: #ffc0f5;
        }

        .chart text {
            fill: white;
            font: 12px sans-serif;
            /*text-anchor: ;*/
        }

        text.caption {
            display: none
        }

        text.caption.interesting {
            display: block;
        }

        .axis text {
            font: 10px sans-serif;
            fill: white;
        }

        .axis path,
        .axis line {
            fill: none;
            stroke: white;
            shape-rendering: crispEdges;
        }

    </style>
</head>
<body>
<h1 class="fix-margins">Visual Ranking: Oceanman Switzerland 2018</h1>
<div class="margins">
    <form role="form">
        <div class="form-inline">
            <p class="input-lg" style="height: auto">
                <span class="text-landscape"> Every dot is one participant. The more
                they are on the left, the faster they are.
                The more on the top, the older. Type your name in the form field to find yourself. Touch the dots to see
                details.</span>
                <span class="text-portrait"> Every dot is one participant. The more
                they are on the top, the faster they are.
                The more on the right, the older. Type your name in the form field to find yourself. Touch the dots to see
                details.</span>
            </p>

            <div class="form-group" style="margin-left: 20px">
                <div class="radio">
                    <label class=" input-lg">
                        <input type="radio" name="race" id="race-sprint" value="sprint"> Sprint
                    </label>
                    <label class=" input-lg">
                        <input type="radio" name="race" id="race-half" value="half"> Half
                    </label>
                    <label class=" input-lg">
                        <input type="radio" name="race" id="race-full" value="full"> Full
                    </label>
                </div>
            </div>


            <label class="control-label input-lg" for="participant">Search for name, bib, team or nationality:</label>
            <input type="text" class="form-control input-lg" id="participant" size="30"
                   placeholder='"igor", "135", "aquatic"'>
            <div class="form-group" style="margin-left: 20px">
                <div class="checkbox">
                    <label class=" input-lg">
                        <input type="checkbox" class="gender" name="gender-male" id="gender-male" value="men" checked>
                        Men
                    </label>
                    <label class=" input-lg">
                        <input type="checkbox" class="gender" name="gender-female" id="gender-female" value="women"
                               checked>
                        Women
                    </label>
                </div>
            </div>
        </div>

    </form>
</div>
<div id="chart" style="width: 100%">
</div>
<div class="margins">
    <p class="input-lg" style="height: auto;display: none" id="share">
        Show this view to your friends by sharing this link: <a href="/" class="url"><span class="url" id="urlText"></span></a>
    <span id="copy-to-clipboard"  class="tooltipped tooltipped-s" aria-label="Copy to clipboard" data-clipboard-target=".url" ><i class="fas fa-copy "></i></span>
    </p>
</div>
<div class="margins fix-margins">&copy; <a href="https://mühlemann.ch">Silvan Mühlemann</a>, 2.9.2018, Data provided by <a
        href="https://www.endu.net/">endu.net</a></div>
<script src="//d3js.org/d3.v3.min.js"></script>
<script type="text/javascript">

    function getParameterByName(name, url) {
        if (!url) url = window.location.href;
        name = name.replace(/[\[\]]/g, "\\$&");
        var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
            results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return '';
        return decodeURIComponent(results[2].replace(/\+/g, " "));
    }


    var chartDiv = document.getElementById("chart");
    var svg = d3.select(chartDiv).append("svg");


    var landscape = true;
    if (window.innerWidth < window.innerHeight) {
        landscape = false;
        var width = chartDiv.clientWidth;
        var height = window.innerHeight;
        $('.text-portrait').show();
        $('.text-landscape').hide();
    } else {
        var width = chartDiv.clientWidth;
        var height = chartDiv.clientWidth / 2.5;
        $('.text-portrait').hide();
        $('.text-landscape').show();
    }

    var margin = {'left': 40, 'right': 80, 'top': 20, 'bottom': 10};

    if (landscape) {
        var x = d3.time.scale()
            .range([margin.left, width - margin.right - margin.left]);

        var y = d3.scale.linear()
            .range([height - margin.top - margin.bottom, margin.top]);

        var xAxis = d3.svg.axis()
            .scale(x)
            .orient('bottom')
            .tickFormat(d3.time.format('%H:%M'));

        var yAxis = d3.svg.axis()
            .scale(y)
            .orient('left');

    } else {
        margin.right = 20;
        margin.left = 40;

        var x = d3.scale.linear()
            .range([margin.left, width - margin.right - margin.left]);

        var y = d3.time.scale()
            .range([margin.top, height - margin.top - margin.bottom]);

        var xAxis = d3.svg.axis()
            .scale(x)
            .orient('bottom');

        var yAxis = d3.svg.axis()
            .scale(y)
            .orient('left')
            .tickFormat(d3.time.format('%H:%M'));
    }


    var chart = svg
        .attr("width", width)
        .attr("height", height)
        .attr("class", 'chart')
        .append("g")
        .attr("transform", "translate(" + (margin.left) + ", " + margin.top + ")");

    $("input.gender").click(function () {
        var gender = $(this).val();
        if ($(this).prop('checked')) {
            $('circle.' + gender).show();
        } else {
            $('circle.' + gender).hide();
        }
    });

    function highlightParticipant(q) {
        jQuery.each(jQuery("circle"), function (ix, e) {
            attr = e.getAttribute('class');

            if (e.getAttribute('data-name').toLowerCase().indexOf(q.toLowerCase()) >= 0) {
                e.setAttribute('class', 'me');
                $(this).parent().find('text').show();
            } else {
                e.setAttribute('class', e.getAttribute('data-gender'));
                $(this).parent().find('text').hide();
            }
        });
    }

    $("#participant").keyup(function () {
        if ($("#participant").val().length >= 3) {
            setTimeout(function() {
                $('#share').fadeIn();
            }, 1000)
            highlightParticipant($("#participant").val());
            var url = window.location.protocol + '//' + window.location.hostname + window.location.pathname + '?bib=' + $("#participant").val()
                + '&race=' + $('input[name=race]:checked').val();
            $('a.url').attr('href', url);
            $('.url').text(url);
        }
    });

    function redraw() {

        var race;
        if (race = $('input[name=race]:checked').val()) {
        } else if (race = getParameterByName('race')) {
        } else {
            race = 'full';
        }
        $('input#race-' + race).prop('checked', true);
        console.log(race);

        var isInteresting = function (d) {

            if (getParameterByName('bib') > 0 && d.Bib == getParameterByName('bib')) {
                return true;
            }

            if (race == 'full') {
                return ["228"].indexOf(d.Bib) >= 0;
            } else if (race == 'half') {
                return ["121"].indexOf(d.Bib) >= 0;
            } else {
                return ["321"].indexOf(d.Bib) >= 0;
            }
            //return false
        };


        //dsv("cityrun-male.csv", type, function (error, data) {
        //dsv("silvesterlauf.csv", type, function (error, data) {
        d3.json("processed-" + race + ".json", function (error, data) {

            d3.selectAll("g.elems").remove();
            d3.selectAll(".axis").remove();

            data = convertType(data);

            if (landscape) {
                x.domain([
                    d3.min(data, function (d) {
                        return d.OffsetTime;
                    }),
                    d3.max(data, function (d) {
                        return d.OffsetTime;
                    })]);

                y.domain(d3.extent(data, function (d) {
                    return d.Age;
                }));

            } else {
                y.domain([
                    d3.min(data, function (d) {
                        return d.OffsetTime;
                    }),
                    d3.max(data, function (d) {
                        return d.OffsetTime;
                    })]);

                x.domain(d3.extent(data, function (d) {
                    return d.Age;
                }));

            }

            // Move the interesting values to the front (z-index in SVG)
            var interestingValues = data.filter(isInteresting);
            var uninterestingValues = data.filter(function (d) {
                return !isInteresting(d);
            });
            data = d3.merge([uninterestingValues, interestingValues]);

            if (landscape) {
                // find max time
                // var maxTime = data.reduce(function (a, d) {
                //     return (a===null || d.OffsetTime > a) ? d.OffsetTime : a;
                // }, data[0].OffsetTime);

                dot = chart.selectAll("g")
                    .data(data)
                    .enter().append("g")
                    .attr("class", "elems")
                    .attr("style", "display:none")
                    .attr("transform", function (d, i) {
                        //return "translate(" + x(maxTime) + "," + y(d.Age) + ")";
                        return "translate(" + x(d.OffsetTime) + "," + y(d.Age + Math.random() * 2 - 1) + ")";
                    })

            } else {
                dot = chart.selectAll("g")
                    .data(data)
                    .enter().append("g")
                    .attr("class", "elems")
                    .attr("transform", function (d, i) {
                        return "translate(" + x(d.Age + Math.random() * 2 - 1) + "," + y(d.OffsetTime) + ")";
                    });
            }

            dot.append('circle')
                .attr('cy', 0)
                .attr('cx', 0)
                .attr("r", "8px")
                .attr("class", function (d) {
                    if (isInteresting(d)) {
                        return "me";
                    }
                    if (d.Gender == 'F') {
                        return "women";
                    } else {
                        return "men";
                    }
                })
                .attr('data-name', function (d) {
                    return d.Name + ", " + d.Cat + ", " + d.Bib;
                })
                .attr('data-time', function (d) {
                    return d.OffsetTime;
                })
                .attr('data-gender', function (d) {
                    if (d.Gender == 'F') {
                        return "women";
                    } else {
                        return "men";
                    }
                })
                .attr('data-age', function (d) {
                    return d.Age;
                });

            dot.append("text", "circle")
                .attr('class', function (d) {
                    return 'caption' + (isInteresting(d) ? ' interesting' : '');
                })
                .attr("y", 0)
                .attr("x", 5)
                .attr("transform", landscape ? "rotate(0)" : "rotate(90)")
                .attr("dy", ".35em")
                .text(function (d) {
                    return d.Rank + ". " + d.Name + ", " + d.Time;
                });

            // dot.transition()
            //     .attr("transform", function (d, i) {
            //         return "translate(" + x(d.OffsetTime) + "," + y(d.Age) + ")";
            //     })
            //     .duration(5000)
            //

            chart.append("g")
                .attr("class", "x axis")
                .call(xAxis)
                .append("text")
                .attr("x", (width - margin.left - margin.right) / 2 + margin.left)
                .attr("y", -15)
                .attr("dy", ".71em")
                .style("text-anchor", "center")
                .text(landscape ? "Finish time" : "Age");

            chart.append("g")
                .attr("class", "y axis")
                .call(yAxis)
                .append("text")
                .attr("transform", "rotate(-90)")
                .attr("y", 6)
                .attr("x", -margin.top + (+margin.bottom + margin.top - height) / 2)
                .attr("dy", ".71em")
                .style("text-anchor", "begin")
                .text(landscape ? "Age" : "Finish time");

            jQuery("circle").click(function () {
                console.log($(this).data().name + " " + $(this).data().age);
            });

            jQuery("circle:not(.interesting)").hover(function () {
                $(this).parent().find('text').fadeIn();
            }, function () {
                $(this).parent().find('text').fadeOut();
            });

            /*$("text.caption").click(function() {
         $(this).show();
         })*/

            var q;
            if (q = getParameterByName('bib')) {
                highlightParticipant(q);
            }
        });

        function convertType(d) {
            for (i = 0; i < d.length; i++) {
                var hms = d[i].Time;   // your input string
                var a = hms.split(':'); // split it at the colons

                if (a.length == 2) {
                    var date = new Date(0, 0, 0, 0, +a[0], +a[1]);
                } else {
                    var date = new Date(0, 0, 0, +a[0], +a[1], +a[2]);
                }
                d[i].OffsetTime = date;
            }

            return d.reverse();
        }

        // Animation to display the dots
        window.setTimeout(function () {
            $('.elems').each(function (ix, e) {
                window.setTimeout(function () {
                    $(e).show();
                }, Math.random() * 500)
            })
        }, 500)

    }

    $('input[name=race]').on('click', function () {
        var race = $('input[name=race]:checked').val();
        redraw();
    });

    clipboard = new ClipboardJS('#copy-to-clipboard');

    clipboard.on('success', function (e) {
        $('#copy-to-clipboard').attr('aria-label', 'Copied!').addClass('tooltipped-no-delay')
        e.clearSelection();
    });

    // Draw for the first time to initialize.
    redraw();

</script>
</body>
</html>